<?php

namespace App\DAO;

use App\DAO\DAOResponse\DAOResponse;
use App\DAO\DAOResponse\DAOResponseInterface;
use App\DAO\Filter\QueryFilter;
use App\DAO\Filter\QueryFilterBuilder;
use App\DAO\Order\QueryOrder;
use App\DAO\Pagination\Pagination;
use App\Entities\CEP\CEP;
use App\Entities\Cliente\Cliente;
use App\Entities\ConfirmacaoEmail\ConfirmacaoEmail;
use App\Entities\Endereco\Endereco;
use App\Entities\Setor\Setor;
use App\Entities\Pessoa\Pessoa;
use App\Entities\PessoaFisica\PessoaFisica;
use App\Entities\Usuario\Usuario;
use App\Entities\UsuarioPerfil\UsuarioPerfil;
use App\Mappers\SetorMapper;
use App\Models\CEPModel;
use App\Models\ClienteModel;
use App\Models\ConfirmacaoEmailModel;
use App\Models\EnderecoModel;
use App\Models\SetorModel;
use App\Models\PessoaFisicaModel;
use App\Models\PessoaModel;
use App\Models\UsuarioModel;
use App\Models\UsuarioPerfilModel;
use App\Services\LogService;
use App\Services\ServiceResponse\ServiceResponseInterface;
use App\Utils\Collections\QueryFilterCollection;
use App\Utils\Collections\QueryOrderCollection;
use App\ViewModels\Setor\SetorUpdateViewModel\SetorUpdateViewModel;
use App\ViewModels\Setor\SetorRegistrationViewModel\SetorRegistrationViewModel;
use Exception;
use Kint\Parser\DOMDocumentPlugin;

class SetorDAO extends DAO {

	public function persistSetorRegistrationVM(SetorRegistrationViewModel $setor_registration_vm): DAOResponse {

		$dao_response = new DAOResponse();
		try {
			$this->db->transStart();
			$setor = $this->persistSetorFromSetorRegistrationVM( $setor_registration_vm );
			$error = $this->db->error();
			if ($error && $error ['code']) {
				$this->setDatabaseErrorsForSetorRegistration( $dao_response, $error );
			} else {
				$dao_response->setStatus( DAOResponseInterface::SUCESS );
				$dao_response->setData( $setor );
				$this->db->transComplete();
			}
		} catch ( Exception $exception ) {
			$this->setDatabaseErrorsForSetorRegistration( $dao_response, $this->db->error() );
		}

		return $dao_response;

	}

	private function setDatabaseErrorsForSetorRegistration(DAOResponse $dao_response, array $error): void {

		if ($error ['code']) {
			$dao_response->setStatus( $error ['code'] );
			$dao_response->setErrors( $this->getDatabaseResponseErrorsForPersistence( $error ) );
		} else {
			$dao_response->setStatus( DAOResponseInterface::DATABASE_CONNECTION_ERROR );
		}
		log_message( 'error', json_encode( $error ) );

	}

	private function persistSetorFromSetorRegistrationVM(SetorRegistrationViewModel &$setor_registration_vm): Setor {

		$setor_model = new SetorModel();
		$setor = SetorMapper::getSetorFromSetorRegistrationVM( $setor_registration_vm );
		$setor_model->registerSetor( $setor );
		if (!$setor->getId()) {
			throw new Exception( 'O cadastro de setor não foi teve êxito' );
		}
		return $setor;

	}

	public function getSetorList(?Pagination $pagination, ?QueryFilterCollection $query_filter_collection, ?QueryOrderCollection $query_order_collection = null): DAOResponse {

		$sql = <<<SQL
		    SELECT 
		    setor.id as id,
		    setor.descricao as descricao,
		    setor.id_centro_custo as id_centro_custo,
		    setor.criado_em as criado_em,
		    setor.atualizado_em as atualizado_em,
		    setor.desativado_em as desativado_em,
		    setor.criado_por as criado_por,
		    setor.alterado_por as alterado_por,
		    setor.desativado_por as desativado_por,
		    centro_custo.descricao as descricao_centro_custo
		    FROM setor 
		        inner join centro_custo on setor.id_centro_custo = centro_custo.id
		SQL;
		$binds = [ ];
		return $this->getDAOResponseFromPaginatedSelect( $binds, $pagination, $query_filter_collection, $query_order_collection, $sql,
				function (array $result_array) {
					return SetorMapper::getSetorDetailsVMListFromArray( $result_array );
				} );

	}

	public function getSetor(QueryFilterCollection $query_filter_collection): DAOResponse {

		$sql = '
            SELECT 
            setor.id as id,
            setor.descricao as descricao,
            setor.id_centro_custo as id_centro_custo,
            setor.criado_em as criado_em,
            setor.atualizado_em as atualizado_em,
            setor.desativado_em as desativado_em,
            setor.criado_por as criado_por,
            setor.alterado_por as alterado_por,
            setor.desativado_por as desativado_por,
            centro_custo.descricao as descricao_centro_custo
            FROM setor 
                inner join centro_custo on setor.id_centro_custo = centro_custo.id
        ';
		$binds = [ ];
		return $this->getDAOResponseFromUniqueRowSelect( $binds, $query_filter_collection, $sql,
				function (array $result_array) {
					$setorVM = SetorMapper::getSetorDetailsVMFromArray( $result_array [0] );
					return $setorVM;
				} );

	}

	public function getSetorFromId(int $id_setor) {

		$sql = "  SELECT * FROM setor WHERE id=? ";

		$binds = [ 
				$id_setor
		];
		$query = $this->db->query( $sql, $binds );
		$result_array = $query->getResultArray();

		return ($result_array);

	}

	public function persistSetorUpdateVM(int $id_paciente, SetorUpdateViewModel $setor_update_vm): DAOResponse {

		$dao_response = new DAOResponse();
		$this->db->transStart();
		$status_persistence = $this->persistSetorFromSetorUpdateVM( $id_paciente, $setor_update_vm );
		$error = $this->db->error();
		if ($error && $error ['code']) {
			$this->setDatabaseErrorsForSetorUpdate( $dao_response, $error );
			return $dao_response;
		} else if ($status_persistence) {
			$this->db->transComplete();
			$dao_response->setStatus( DAOResponseInterface::SUCESS );
		}
		$this->db->close();
		return $dao_response;

	}

	private function setDatabaseErrorsForSetorUpdate(DAOResponse $dao_response, array $error): void {

		$dao_response->setStatus( $error ['code'] );
		$dao_response->setErrors( $this->getDatabaseResponseErrorsForPersistence( $error ) );

	}

	private function persistSetorFromSetorUpdateVM(int $id_paciente, SetorUpdateViewModel &$setor_update_vm): bool {

		$setor_model = new SetorModel();
		$setor = SetorMapper::getSetorFromSetorUpdateVM( $setor_update_vm );
		$sucess_update = $setor_model->updateSetorByID( $id_paciente, $setor );
		return $sucess_update;

	}

	private function getDatabaseResponseErrorsForPersistence(array $error): array {

		$dao_response_errors = [ ];
		if ($error && $error ['code']) {
			if ($error ['code'] === DAOResponseInterface::FOREIGN_KEY_DONT_EXISTS) {
				if (strpos( $error ['message'], 'cep' ) !== false) {
					$dao_response_errors ['cep'] = 'Esse CEP não existe.';
				}
			} else if ($error ['code'] === DAOResponseInterface::DUPLICATED_UNIQUE_KEY) {
				if (strpos( $error ['message'], '\'cpf\'' ) !== false) {
					$dao_response_errors ['cpf'] = 'Uma pessoa com esse CPF já está cadastrada no sistema.';
				}
				if (strpos( $error ['message'], '\'pessoa_fisica.rg\'' ) !== false) {
					$dao_response_errors ['rg'] = 'Uma pessoa com esse RG já está cadastrada no sistema.';
				}
				if (strpos( $error ['message'], '\'email\'' ) !== false) {
					$dao_response_errors ['email'] = 'Uma pessoa com esse email já está cadastrada no sistema.';
				}
			}
		}
		return $dao_response_errors;

	}

	public function persistSetorDeleteVM(int $id_paciente): DAOResponse {

		$dao_response = new DAOResponse();
		$this->db->transStart();
		$status_persistence = $this->deleteSetor( $id_paciente );
		$error = $this->db->error();
		if ($error && $error ['code']) {
			$this->setDatabaseErrorsForSetorUpdate( $dao_response, $error );
			return $dao_response;
		} else if ($status_persistence) {
			$this->db->transComplete();
			$dao_response->setStatus( DAOResponseInterface::SUCESS );
		}
		$this->db->close();
		return $dao_response;

	}

	public function deleteSetor(int $id_setor): bool {

		$setor_model = new SetorModel();
		$sucess_update = $setor_model->deleteSetorByID( $id_setor );
		return $sucess_update;

	}

}
